//
//  NSArray+MulleApply.m
//  MulleAutoreleasePool
//
//  Created by Nat! on Wed Dec 17 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import "NSArray+MulleApply.h"

#define USE_R12 1

#if USE_R12
#include <objc/objc-runtime.h>
#endif


@implementation NSArray ( MulleApply)



static inline Class   _isa( NSObject *obj)
{
   return( ((struct { @defs( NSObject) } *) obj)->isa);
}


#define N_MULLE_AUTORELEASE_CLASS_LINES__         64
#define N_MULLE_AUTORELEASE_CLASS_MASK__          0x3F
#define N_MULLE_AUTORELEASE_CLASS_SHIFT_          4
#define N_MULLE_AUTORELEASE_CLASS_MODULO__        61

// this is slower, because I can't directly into the internal storage.
- (void) mulleMakeObjectsPerformSelector:(SEL) performSel
{
   IMP            lastRelease[ N_MULLE_AUTORELEASE_CLASS_LINES__];
   Class          lastIsa[ N_MULLE_AUTORELEASE_CLASS_LINES__];
   Class          thisIsa;
   NSObject       *p;
   unsigned int   index;
   unsigned int   i;
   unsigned int   n;
   IMP            impl;
   IMP            impObjectAtIndex;
   SEL            selObjectAtIndex;
    
   selObjectAtIndex = @selector( objectAtIndex:);
   impObjectAtIndex = [self methodForSelector:selObjectAtIndex];

   n = [self count];
   //
   // next step, move this up from cache to hash table, w/o losing speed
   // 
      
   memset( lastIsa, 0, sizeof( lastIsa));
   for( i = 0; i < n; i++)
   {
      p       = (*impObjectAtIndex)( self, selObjectAtIndex, i);
      thisIsa = _isa( p);
            
      index = ((unsigned long) thisIsa >> N_MULLE_AUTORELEASE_CLASS_SHIFT_) % N_MULLE_AUTORELEASE_CLASS_MODULO__; 
            
      if( lastIsa[ index] != thisIsa)
      {
         lastIsa[ index] = thisIsa;
#if USE_R12
         objc_msgSend( p, performSel);
         asm volatile ( "mr  %0,r12"  : "=r" ( impl) : : "r12");
         lastRelease[ index] = impl;
         continue;
#else
         lastRelease[ index] = [thisIsa instanceMethodForSelector:performSel];
         // "fall thru"
#endif            
      }
      (*lastRelease[ index])( p, performSel);
   }
}
 



@end
